﻿; AuroraSaveGame is an utility to add save game functionalities in Aurora (game by Steve Walmsley -http://aurora2.pentarch.org/)
;
; When launching this tool, if Aurora is running (classic game or using AuroraPatch), you can use the hotkey "CTRL + Q" to save the game.
; In addition, you can enable an autosave and precise an interval in minutes.
; ***********************************************************************************************************************************************

#SingleInstance, force
#Persistent


; ******************************************* firstly, detect the game 

if WinExist("ahk_exe AuroraPatch.exe")
{
	aurora_launched := 1
	WinGetClass, aurora_class_temp, ahk_exe AuroraPatch.exe
	aurora_class := "ahk_class " aurora_class_temp
}	

else if WinExist("ahk_exe Aurora.exe")
{
	aurora_launched := 1
	WinGetClass, aurora_class_temp, ahk_exe Aurora.exe
	aurora_class := "ahk_class " aurora_class_temp
}

else
	aurora_launched := 0


; ******************************************* if game is launched

if(aurora_launched = 1)
{
		
	;MsgBox, 0, Titre, %aurora_class%
	
	; ******************************************* get the main screen ID
	WinGet, WinList, List, %aurora_class%													; list windows of Aurora
	loop, % WinList
	{
		WinGetTitle, winTitle, % "ahk_id " WinList%A_Index%								; get titles of all windows
		
		if InStr(winTitle, "Racial Wealth")												; if main windows found (containing Racial Wealth)
		{
			aurora_main_id = % "ahk_id " WinList%A_Index%			
		}
	}
	
	temp_var := SubStr(aurora_class, InStr(aurora_class, "app"))		; get the app ID
	save_form := "WindowsForms10.BUTTON." temp_var "109"				; concat with button specs !!! if this button change in Aurora, could not work anymore !!!
	
	
	
	; ******************************************* ask user for autosave
	MsgBox, 4, Welcome to AuroraSaveGame !, Do you want to activate AutoSave ?

	ifMsgBox Yes
	{
		autosave :=1
		done := False
		Loop 
		{
		InputBox, timeAutosave, Welcome to AuroraSaveGame !, Time in minutes for autosave (min 1) :
		If ErrorLevel
			ExitApp
		If timeAutosave is integer
		{
			If (timeAutosave > 0)
				done := True
			Else MsgBox, 48, Error, Please enter an integer > 0.			
		}
		
		Else MsgBox, 48, Error, Please enter an integer.
		} Until done
		
		MsgBox, 0, Welcome to AuroraSaveGame !, You can use CTRL + Q from any Aurora screen to save. `nAutosave enabled every %timeAutosave% minutes. 
		timeAutosave_minutes := timeAutosave * 60000										; convert ms to second
		
		
		
	}

	else
	{
		MsgBox, 0, Welcome to AuroraSaveGame !, You can use CTRL + Q from main Aurora screen to save. `nNo autosave enabled. 
		
	}
	
	
	
	; ******************************************* main 
			
	
	
	
	if (autosave =1)
	{
		Sleep, %timeAutosave_minutes%
		SetTimer, Autosave, %timeAutosave_minutes%
		;MsgBox, 0, Titre de la boîte de dialogue, %aurora_class%.
		;MsgBox, 0, Titre de la boîte de dialogue, %aurora_main_id%.
		;MsgBox, 0, Titre de la boîte de dialogue, %save_form%.
		

		Autosave:
		{	
			if !WinExist(aurora_class)														; leave if game is closed
				ExitApp
			ControlClick, %save_form% ,  %aurora_main_id%			
			return			
		}						
	}	
	
	
	^q::
	{
		;MsgBox, 0, Titre de la boîte de dialogue, %aurora_class%.
		;MsgBox, 0, Titre de la boîte de dialogue, %save_form%.
		;MsgBox, 0, Titre de la boîte de dialogue, %aurora_main_id%.
		
		if !WinExist(aurora_class)														; leave if game is closed
			ExitApp		
			
		ControlClick, %save_form% ,  %aurora_main_id%
		if (autosave =1)
			SetTimer, Autosave, %timeAutosave_minutes%									; reset timer
		
		return
	}
	
	
	
	
}

; ******************************************* if game isn't launched
else
{
	MsgBox, 0, Welcome to AuroraSaveGame !, Game is not running.
	ExitApp
}
